;;;; hooks.scm - Forum hooks -*- scheme -*-
;;;; Copyright (C) 2001  Neal H Walfield  <neal@cs.uml.edu>
;;;;
;;;; This file is part of Deride
;;;;
;;;; Deride is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2, or (at your option)
;;;; any later version.
;;;; 
;;;; Deride is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with the Deride; see the file COPYING.  If not, write to
;;;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(define-module (forum hooks))

;;; These hooks are called by the forum backend.

;; A user joined a forum.
;;
;; Argument 1: The user
;;          2: The forum
;;          3: The reason

(define-public forum-user-joined-hook (make-hook 3))

;; A user parted a forum.
;;
;; Argument 1: The user
;;          2: The forum
;;          3: The reason why the user left.

(define-public forum-user-parted-hook (make-hook 3))

;; A user quit, i.e. parted all forums.
;;
;; Argument 1: The user
;;          2: A list of forums he a member of
;;          3: A reason why the user left.
;;
;; NB: The forum-user-parted-hook is NOT called in this case.

(define-public forum-user-quit-hook (make-hook 3))

;; A user changed their nick name.
;;
;; Argument 1: old-nick 
;;          2: new-nick
;;          3: A list of forums he is on.
;;          4: The reason for the change.

(define-public forum-user-schizophrenia-hook (make-hook 4))
